{% extends 'inventory/base.html' %}
{% load static %}
{% load crispy_forms_tags %}

{% block title %} | Fill Order {% endblock %}

{% block content %}
    {% if audio == 'scan-success.wav' %}
        <audio src="{% static 'sounds/scan-success.wav' %}" autoplay></audio>
    {% elif audio == 'scan-fail.wav' %}
        <audio src="{% static 'sounds/scan-fail.wav' %}" autoplay></audio>
    {% endif %}
    <div class="container">
        <h1 class="m-3 text-center">Fill Order</h1>
        <div class="d-flex flex-row align-items-center justify-content-between mx-3">
            <h3 class="text-center">#{{ order.id }} for {{ order.user.first_name }} {{ order.user.last_name }}</h3>
            {% if order.status == "SUBMITTED" %}
                <form onsubmit="submit_form(event)">
                    {% csrf_token %}
                    <input type="hidden" name="action" value="process">
                    <button type="submit" class="btn btn-primary">Process Order</button>
                </form>
            {% elif order.status == "PROCESSING" %}
                <form onsubmit="submit_form(event)">
                    {% csrf_token %}
                    <input type="hidden" name="action" value="unprocess">
                    <button type="submit" class="btn btn-info">Stop Processing</button>
                </form>
            {% endif %}
        </div>

        {% if order.status == "PROCESSING" %}
            <form method="post">
                {% csrf_token %}
                <input type="hidden" name="action" value="barcode">
                <div class="input-group input-group-lg my-3">
                    <input type="text" name="barcode" class="form-control" type=text placeholder="Barcode" autofocus>
                    <div class="input-group-append">
                        <button class="btn btn-success" type="submit"><i class="fas fa-qrcode"></i></button>
                    </div>
                </div>
            </form>
        {% endif %}

        {% for part_order, locations in part_orders %}
            <div class="card m-3 {% if part_order.fulfilled_quantity == part_order.quantity %} bg-success {% elif part_order.fulfilled_quantity > part_order.quantity %} bg-danger {% elif part_order.fulfilled_quantity > 0 %} bg-warning {% endif %}">
                <div class="card-header d-flex flex-row align-items-center justify-content-between">
                    <div class="d-flex flex-row align-items-center">
                        <h5 class="m-0 mr-3">
                            <a href="{% url 'part' part_id=part_order.part.id %}">{{ part_order.part.name }}</a>
                        </h5>
                        <span>#{{ part_order.part.id }}, {{part_order.part.manufacturer_part_number}}</span>
                    </div>
                    <span>{{ part_order.fulfilled_quantity }} / {{ part_order.quantity }}</span>
                </div>
                <div class="list-group list-group-flush">
                    {% for part_location, fulfillment in locations %}
                        {% if part_location.primary_location %}
                            <div class="list-group-item {% if part_order.fulfilled_quantity >= part_order.quantity %} border-success {% elif part_order.fulfilled_quantity > part_order.quantity %} border-danger {% elif part_order.fulfilled_quantity > 0 %} border-warning {% endif %}">
                                <div class="d-flex flex-row justify-content-between align-items-right">
                                    <div class="d-flex flex-column">
                                        {% for parent_location in part_location.location.parents reversed %}
                                            <p class = "mb-0">{{ parent_location.name }} </p>
                                        {% endfor %}
                                        <p>{{ part_location.location.name}}</p>
                                        <p class="mb-0">{{ part_location.quantity }}</p>
                                    </div>
                                    {% if order.status == "PROCESSING" %}
                                        <div>
                                            <div class="btn-toolbar">
                                                {% if fulfillment == None %}
                                                    <form onsubmit="submit_form(event)">
                                                        {% csrf_token %}
                                                        <input type="hidden" name="action" value="add">
                                                        <input type="hidden" name="part_order" value="{{ part_order.id }}">
                                                        <input type="hidden" name="part_location" value="{{ part_location.id }}">
                                                        <button type="submit" class="btn btn-primary"><i class="fas fa-plus"></i></button>
                                                    </form>
                                                {% else %}
                                                    <form onsubmit="submit_form(event)">
                                                        {% csrf_token%}
                                                        <input type="hidden" name="action" value="edit">
                                                        <input type="hidden" name="fulfillment" value="{{ fulfillment.id }}">
                                                        <div class="input-group">
                                                            <input
                                                                    type="text"
                                                                    name="quantity"
                                                                    placeholder="{{ fulfillment.quantity }}"
                                                                    class="form-control text-right"
                                                                    style="width: 4em"
                                                                    autocomplete="off"
                                                            >
                                                            <div class="input-group-append">
                                                                <button class="btn btn-primary"><i class="fas fa-check"></i></button>
                                                            </div>
                                                        </div>
                                                    </form>
                                                    <form onsubmit="submit_form(event)">
                                                        {% csrf_token%}
                                                        <input type="hidden" name="action" value="remove">
                                                        <input type="hidden" name="fulfillment" value="{{ fulfillment.id }}">
                                                        <button class="btn btn-danger ml-2"><i class="fas fa-trash"></i></button>
                                                    </form>
                                                {% endif %}
                                                <div class="btn-group btn-group ml-2">
                                                    <button type="button" class="btn btn-success" data-toggle="modal" data-target="#part_location_{{ part_order.id }}_{{ part_location.id }}"><i class="fas fa-edit"></i></button>
                                                    <button type="button" class="btn btn-info" data-toggle="modal" data-target="#refill_{{ part_order.id }}_{{ part_location.id }}">Refill</button>
                                                </div>
                                            </div>
                                        </div>
                                    {% endif %}
                                </div>
                            </div>
                            {% if order.status == "PROCESSING" %}
                                <div class="modal" id="part_location_{{ part_order.id }}_{{ part_location.id }}" tabindex="-1" role="dialog">
                                    <div class="modal-dialog modal-lg" role="document">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title">Edit Part Location</h5>
                                                <button type="button" class="close" data-dismiss="modal">
                                                    <i class="fas fa-times"></i>
                                                </button>
                                            </div>
                                            <div class="modal-body">
                                                <form onsubmit="submit_form(event)">
                                                    {% csrf_token %}
                                                    <input type="hidden" name="action" value="part_location">
                                                    <input type="hidden" name="part_location" value="{{ part_location.id }}">
                                                    <div class="form-group row mx-2">
                                                        <label for="quantity" class="col-form-label">Quantity</label>
                                                        <div class="col">
                                                            <input type="text" class="form-control" placeholder="{{ part_location.quantity }}" name="quantity">
                                                        </div>
                                                    </div>
                                                    <button type="submit" class="btn btn-primary">Submit</button>
                                                </form>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="modal" id="refill_{{ part_order.id }}_{{ part_location.id }}" tabindex="-1" role="dialog">
                                    <div class="modal-dialog modal-lg" role="document">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title">Edit Part Location</h5>
                                                <button type="button" class="close" data-dismiss="modal">
                                                    <i class="fas fa-times"></i>
                                                </button>
                                            </div>
                                            <div class="modal-body">
                                                {% if part_location.part.partlocation_set.count > 1 %}
                                                    <form onsubmit="submit_form(event)">
                                                        {% csrf_token %}
                                                        <input type="hidden" name="action" value="refill">
                                                        <input type="hidden" name="part_location" value="{{ part_location.id }}">

                                                        <fieldset class="mb-3">
                                                            {% for refill_part_location in part_location.part.partlocation_set.all %}
                                                                {% if refill_part_location != part_location and not refill_part_location.primary_location %}
                                                                    <div class="form-check">
                                                                        <input type="radio" name="refill_part_location" id="{{ refill_part_location.id }}_radio" value="{{ refill_part_location.id }}" class="form-check-input">
                                                                        <label for="{{ refill_part_location.id }}_radio" class="form-check-label d-flex flex-row align-items-center justify-content-between">
                                                                            <span>{{ refill_part_location.location }}</span>
                                                                            <span>{{ refill_part_location.quantity }}</span>
                                                                        </label>
                                                                    </div>
                                                                {% endif %}
                                                            {% endfor %}
                                                        </fieldset>

                                                        <div class="form-group row mx-2">
                                                            <label for="quantity" class="col-form-label">Quantity</label>
                                                            <div class="col">
                                                                <input type="text" class="form-control" name="quantity">
                                                            </div>
                                                        </div>
                                                        <button type="submit" class="btn btn-primary">Submit</button>
                                                    </form>
                                                {% else %}
                                                    <p>There are no other locations with this part to refill from</p>
                                                {% endif %}
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            {% endif %}
                        {% endif %}
                    {% endfor %}
                </div>
            </div>
        {% endfor %}
        {% if order.status == "PROCESSING" %}
            <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#complete">Complete Order</button>
            <div class="modal" id="complete" tabindex="-1" role="dialog">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title">Complete Order #{{ order.id }} for {{ order.user.first_name }} {{ order.user.last_name }}</h5>
                            <button type="button" class="close" data-dismiss="modal">
                                <i class="fas fa-times"></i>
                            </button>
                        </div>
                        <div class="modal-body p-0">
                            <div class="list-group list-group-flush">
                                {% for part_order, locations in part_orders %}
                                    <div class="list-group-item d-flex flex-row align-items-center justify-content-between {% if part_order.fulfilled_quantity == part_order.quantity %} bg-success {% elif part_order.fulfilled_quantity > part_order.quantity %} bg-danger {% else %} bg-warning {% endif %}">
                                        <span>{{ part_order.part.name }}</span>
                                        <span>{{ part_order.fulfilled_quantity }} / {{ part_order.quantity }}</span>
                                    </div>
                                {% endfor %}
                            </div>
                        </div>
                        <div class="modal-footer d-flex flex-row align-items-center justify-content-between">
                            <button class="btn btn-danger" data-dismiss="modal">Cancel</button>
                            <form method="POST">
                                {% csrf_token %}
                                <input type="hidden" name="action" value="complete">
                                <button type="submit" class="btn btn-primary">Submit</button>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        {% endif %}
    </div>
{% endblock %}
